export declare enum OptionType {
    None = 0,
    Some = 1,
}
export declare const optional: <T>(value: T) => Option<T>;
export declare class Option<T> {
    readonly value: T;
    readonly type: OptionType;
    constructor(value: T);
    k<K extends keyof T>(key: K): Option<T[K]>;
    i: T extends Array<infer I> ? (index: number) => Option<I> : Option<undefined>;
    get(): T;
    match({some, none}: {
        some: (v: T) => any;
        none: (v: T) => any;
    }): any;
    getOrElse(value: T): T;
}
